#ifndef EUCALYPTUS_ADDRESSBOOK_H
#define EUCALYPTUS_ADDRESSBOOK_H

/*
 * Eucalyptus
 * by Paul A. Schifferer
 *
 * Header: addressbook.h
 *         Address book structures
 *
 * Copyright  1997,8 Isengard Developments
 * All rights reserved.
 */

struct _AddressEntry
{
     struct List   		*Members,
     				 Items;
     glong                Count,
                          Flags;
};

// AddressEntry Flags
#define AEF_ISMEMBER          (1L << 0)
#define AEF_ISML              (1L << 1)
#define AEF_HIDE              (1L << 2)
#define AEF_ENCRYPT           (1L << 3)
#define AEF_SIGN              (1L << 4)
#define AEF_MARKED            (1L << 5)

struct _AddrEntryItem
{
	glong			 Type;
	gchar			*Item,
					*Value,
					*Label;
	GtkWidget			*Widget;
};

/* AddrEntryItem Types
 * These are some common types that can
 * be used.  Mainly, they are for controlling
 * input into the widgets.
 */
enum
{
	AEIT_STRING=0,
	AEIT_INT,
	AEIT_DATE,
	AEIT_BIRTHDAY,
	AEIT_EMAIL,
	AEIT_URL,
	AEIT_PAGE,	// for marking page breaks
	AEIT_MAX
};

// AddressEntry MailFormats
#define AEMFT_PLAIN           (0)
#define AEMFT_ENRICHED        (1)
#define AEMFT_HTML            (2)

// PGPSign types
#define PGPSIGN_ASK           (0)
#define PGPSIGN_ALWAYS        (1)
#define PGPSIGN_NEVER         (2)

// PGPEncrypt types
#define PGPENCRYPT_ASK        (0)
#define PGPENCRYPT_ALWAYS     (1)
#define PGPENCRYPT_NEVER      (2)

// MailFormat types
// same as compose format types

#endif /* EUCALYPTUS_ADDRESSBOOK_H */