/*
 * Eucalyptus
 * by Paul A. Schifferer
 *
 * Module: compose_address.c
 *   	 Mail composition address functions
 *
 * Copyright  1997-9 Isengard Developments
 * All rights reserved.
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>

#include "eucalyptus.h"

CompAddress *compose_address_new(void)
{
	CompAddress *caddr = NULL;
	
	if(caddr = g_malloc0(sizeof(CompAttachment)))
	{
	}
	
	return caddr;
}

void compose_address_free(CompAddress *caddr)
{
	if(!caddr)
		return;
		
	g_free(caddr);
}

gboolean compose_address_add(Composition *comp, gchar *from, gchar format, glong type)
{
	   GtkWidget *widget = NULL;
	GString *gstr;
	gchar buf[1024], *work, name[1024], addr[1024];
	gboolean success = TRUE;

	memset(buf, 0, sizeof(buf));

	switch(format)
	{
		gchar *c;
		
		case ACAFT_ADDRESS:
			if(c = strchr(from, '<'))
				strncpy(buf, from, sizeof(buf) - 1);
			else
			{
				work = g_strdup_printf("<%s>", from);
				strncpy(buf, work, sizeof(buf) - 1);
				g_free(work);
			}
			break;

		case ACAFT_NAME:
			strncpy(buf, from, sizeof(buf) - 1);
			break;

		case ACAFT_PARSE:
			parse_address(from, name, sizeof(name), addr, sizeof(addr), 0);
			if(*name && *addr)
				work = g_strdup_printf("%s <%s>", name, addr);
			else if(*name && !*addr)
				work = g_strdup(name);
			else
				work = g_strdup(addr);

			strncpy(buf, work, sizeof(buf) - 1);
			g_free(work);
			break;
	}

	/* Add buf to the proper string.
	 */
	switch(type)
	{
		case CAT_CC:
			gstr = comp->str.Cc;
			widget = comp->w.AddrCc;
			break;

		case CAT_BCC:
			gstr = comp->str.Bcc;
			widget = comp->w.AddrBcc;
			break;

		default:
			gstr = comp->str.To;
			widget = comp->w.AddrTo;
			break;
	}

	if(*gstr->str)
		g_string_append(gstr, "; ");
	g_string_append(gstr, buf);

	if(widget)
		   gtk_entry_set_text(GTK_ENTRY(widget), gstr->str);

	return success;
}


