/*
 * Eucalyptus
 * by Paul A. Schifferer
 *
 * Module: compose_custom.c
 *   	 Custom headers
 *
 * Copyright  1997-9 Isengard Developments
 * All rights reserved.
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <math.h>
#include <time.h>

#include "eucalyptus.h"

#if 0
LONG MoreMsgHeaders(Composition *comp)
{
	struct Window *window;
	Object *winobj;
	struct Gadget *layout, *listbrowser, *header, *del;
	struct Node *node = NULL;
	BOOL done = FALSE;

	if(!(winobj = NewObject(WINDOW_GetClass(), NULL,
			WINDOW_Position,    		WPOS_CENTERSCREEN,
			WA_InnerWidth, 			300,
			WA_InnerHeight,			220,

			WA_CloseGadget,			TRUE,
			WA_DragBar,    			TRUE,
			WA_DepthGadget,			TRUE,
			WA_SizeGadget, 			TRUE,
			WA_SizeBRight, 			TRUE,
			WA_Activate,   			TRUE,
			WA_AutoAdjust, 			TRUE,
			WINDOW_BackFillName,		sprefs->Backfill,

			WA_Title, 				LocaleString(ETXT_TITLE_MSGHEADERS),
			WA_ScreenTitle,			eucsctitle,
			WA_PubScreen,  			euc.Screen,

			WINDOW_Layout, 	layout = VLayoutObject,
				LAYOUT_DeferLayout, 	TRUE,
				LAYOUT_SpaceOuter,  TRUE,
				StartMember,   	listbrowser = ListBrowserObject,
					LISTBROWSER_Labels, 	&comp->CustomHeaders,
					LISTBROWSER_AutoFit,	TRUE,
					LISTBROWSER_ShowSelected,TRUE,
					GA_ID,    			GAD_MSGHEADERS_LISTBROWSER,
					GA_RelVerify,  		TRUE,
				EndMember,
				StartHGroup,
					StartMember,   header = StringObject,
						STRINGA_TextVal,    "",
						STRINGA_MaxChars,   WORKLEN - 1,
						GA_TabCycle,   	TRUE,
						GA_ID,    		GAD_MSGHEADERS_HEADER,
						GA_RelVerify,  	TRUE,
					EndMember,
					StartMember,   del = ButtonObject,
						GA_Text,  		LocaleString(ETXT_GAD_MSGHEADERS_DEL),
						GA_ID,    		GAD_MSGHEADERS_DEL,
						GA_RelVerify,  	TRUE,
						GA_Disabled,   	TRUE,
					EndMember,
					CHILD_WeightedWidth,    0,
				EndGroup,
				CHILD_WeightedHeight,    0,
			End,
			TAG_END)))
		return(err_UNABLETOOPENWINDOW);

	if(!(window = CA_OpenWindow(winobj)))
		return(err_UNABLETOOPENWINDOW);

	ActivateLayoutGadget(layout, window, NULL, header);

	while(!done)
	{
		LONG signals;

		signals = Wait((1L << window->UserPort->mp_SigBit) |
					SIG_KILL);

		if(signals & SIG_KILL)
		{
			Signal(FindTask(NULL), SIG_KILL);
			break;
		}

		if(signals & (1L << window->UserPort->mp_SigBit))
		{
			LONG result, code = 0;

			while(WMHI_LASTMSG != (result = CA_HandleInput(winobj, code)))
			{
				switch(result & WMHI_CLASSMASK)
				{
					LONG val;
					STRPTR text;

					case WMHI_CLOSEWINDOW:
						done = TRUE;
						break;
					case WMHI_GADGETUP:
						switch(result & WMHI_GADGETMASK)
						{
							case GAD_MSGHEADERS_LISTBROWSER:
								GetAttr(LISTBROWSER_Selected, listbrowser, (ULONG *)&val);
								if(node = GetListNum(&comp->CustomHeaders, val))
								{
									if(SetGadgetAttrs(header, window, NULL,
											STRINGA_TextVal,    	node->ln_Name,
											TAG_END))
										RefreshGList(header, window, NULL, 1);
									if(SetGadgetAttrs(del, window, NULL,
											GA_Disabled,   		!node,
											TAG_END))
										RefreshGList(del, window, NULL, 1);
								}
								break;
							case GAD_MSGHEADERS_HEADER:
								GetAttr(STRINGA_TextVal, header, (ULONG *)&text);
								if(text &&
								   strlen(text))
								{
									UBYTE *c, *x;

									if(node)
									{
										UBYTE *newtext;

										if(newtext = (UBYTE *)AllocVec(strlen(text) + 1, MEMF_CLEAR))
										{
											strcpy(newtext, text);

											if(c = strchr(newtext, ':'))
											{
												*c = '\0';
												x = strchr(newtext, ' ');
												*c = ':';

												if(x)
													strcpy(x, c);
											}

											FreeVec(node->ln_Name);
											LBEditNode(listbrowser, window, NULL, node,
													LBNA_Column,   	0,
														LBNCA_Text,    	newtext,
													TAG_END);
											node->ln_Name = newtext;
										}
									}
									else
									{
										if(node = LBAddNode(listbrowser, window, NULL, NULL,
												LBNA_Selected, 	TRUE,
												TAG_END))
										{
											if(node->ln_Name = (UBYTE *)AllocVec(strlen(text) + 1, MEMF_CLEAR))
											{
												strcpy(node->ln_Name, text);

												if(c = strchr(node->ln_Name, ':'))
												{
													*c = '\0';
													x = strchr(node->ln_Name, ' ');
													*c = ':';

													if(x)
														strcpy(x, c);
												}

												LBEditNode(listbrowser, window, NULL, node,
														LBNA_Column,   	0,
															LBNCA_Text,    	node->ln_Name,
														TAG_END);
											}
											else
											{
												LBRemNode(listbrowser, window, NULL, node);
											}
										}
									}
								}
								if(SetGadgetAttrs(header, window, NULL,
										STRINGA_TextVal,    	"",
										TAG_END))
									RefreshGList(header, window, NULL, 1);
								break;
							case GAD_MSGHEADERS_DEL:
								if(!node)
									break;
								LBRemNode(listbrowser, window, NULL, node);
								node = NULL;
								if(SetGadgetAttrs(header, window, NULL,
										STRINGA_TextVal,    	"",
										TAG_END))
									RefreshGList(header, window, NULL, 1);
								break;
						}

						ActivateLayoutGadget(layout, window, NULL, header);
						break;
				}
			}
		}
	}

	if(winobj)
		DisposeObject(winobj);
}
#endif

