/*
 * Eucalyptus
 * by Paul A. Schifferer
 *
 * Module: compose_support.c
 *   	 Support functions for composing
 *
 * Copyright  1997-9 Isengard Developments
 * All rights reserved.
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <math.h>
#include <time.h>

#include "eucalyptus.h"

QueueInfo *compose_get_queue_info(gchar *status)
{
	QueueInfo *qi = NULL;
#if 0
	struct List *sched_types = NULL;
	UBYTE *c, *e;
	BOOL done = FALSE, abort = FALSE;

	if(!status)
		return(NULL);

	if(!(qi = (struct QueueInfo *)AllocVec(sizeof(struct QueueInfo), MEMF_CLEAR)))
		goto thatsit;

	if(!(sched_types = ChooserLabels(LocaleString(ETXT_QUEUEINFO_SCHEDTYPE_NONE),
							   LocaleString(ETXT_QUEUEINFO_SCHEDTYPE_AT),
							   LocaleString(ETXT_QUEUEINFO_SCHEDTYPE_EVERY),
							   NULL)))
		goto thatsit;

	if(strstr(status, "Sus;"))
		qi->Suspend = TRUE;

	if((c = strstr(status, "At ")) ||
	   (c = strstr(status, "Every ")))
	{
		if(!strnicmp(c, "At ", 3))
			qi->Type = QUEUE_AT;
		if(!strnicmp(c, "Every ", 6))
			qi->Type = QUEUE_EVERY;

		if(e = strchr(c, ';'))
		{
			*e = '\0';
			strncpy(qi->Date, c, sizeof(qi->Date) - 1);
			*e = ';';
		}
	}

	if(!(winobj = NewObject(WINDOW_GetClass(), NULL,
			WINDOW_Position,    	WPOS_CENTERSCREEN,

			WA_Activate,   		TRUE,
			WA_CloseGadget,		TRUE,
			WA_DragBar,    		TRUE,
			WA_DepthGadget,		TRUE,
			WA_SizeGadget, 		TRUE,
			WA_SizeBBottom,		TRUE,
			WA_RMBTrap,    		TRUE,
			WINDOW_BackFillName,	sprefs->Backfill,

			WA_PubScreen,  		euc.Screen,
			WA_Title, 			LocaleString(ETXT_TITLE_QUEUEINFO),
			WA_ScreenTitle,		eucsctitle,

			WINDOW_Layout, 		layout = VGroupObject,
				LAYOUT_DeferLayout, TRUE,
				StartVGroup,
					LAYOUT_SpaceOuter,  TRUE,
					StartMember,   	suspend = CheckBoxObject,
						GA_Text,  		LocaleString(ETXT_GAD_QUEUEINFO_SUSPEND),
						GA_Selected,   	qi->Suspend,
						CHECKBOX_TextPlace, PLACETEXT_LEFT,
						GA_ID,    		GAD_QUEUEINFO_SUSPEND,
						GA_RelVerify,  	TRUE,
					EndMember,
					StartVGroup,
						LAYOUT_Label,  	LocaleString(ETXT_QUEUEINFO_GROUP_SCHEDULE),
						LAYOUT_BevelStyle,  BVS_GROUP,
						LAYOUT_SpaceOuter,  TRUE,
						StartMember,   schedtype = PopUpObject,
							CHOOSER_Labels,	sched_types,
							CHOOSER_AutoFit,    TRUE,
							CHOOSER_Active,	qi->Type,
							GA_ID,    		GAD_QUEUEINFO_SCHEDTYPE,
							GA_RelVerify,  	TRUE,
						EndMember,
						StartMember,   when = StringObject,
							STRINGA_TextVal,    qi->Date,
							STRINGA_MaxChars,   sizeof(qi->Date) - 1,
							GA_ID,    		GAD_QUEUEINFO_WHEN,
							GA_RelVerify,  	TRUE,
						EndMember,
					EndGroup,
				EndGroup,
				StartImage,    BevelObject,
					BEVEL_Style,   BVS_SBAR_VERT,
				EndImage,
				StartHGroup,
					LAYOUT_SpaceOuter,  TRUE,
					StartMember,   ButtonObject,
						GA_Text,  	LocaleString(ETXT_GAD_QUEUEINFO_OKAY),
						GA_ID,    	GAD_QUEUEINFO_OKAY,
						GA_RelVerify,  TRUE,
					EndMember,
				EndGroup,
			End,
			TAG_END)))
		goto thatsit;

	// open window
	if(!(window = CA_OpenWindow(winobj)))
		goto thatsit;

	while(!done)
	{
		LONG signals;

		signals = Wait((1L << window->UserPort->mp_SigBit) |
					SIG_KILL);

		if(signals & SIG_KILL)
		{
			Signal(FindTask(NULL), SIG_KILL);
			abort = TRUE;
			FreeQueueInfo(qi);
			qi = NULL;
			break;
		}

		if(signals & (1L << window->UserPort->mp_SigBit))
		{
			LONG result, code = 0;

			while(WMHI_LASTMSG != (result = CA_HandleInput(winobj, code)))
			{
				LONG val;
				STRPTR text;

				switch(result & WMHI_CLASSMASK)
				{
					case WMHI_CLOSEWINDOW:
						done = TRUE;
						FreeQueueInfo(qi);
						qi = NULL;
						break;
					case WMHI_GADGETUP:
						switch(result & WMHI_GADGETMASK)
						{
							case GAD_QUEUEINFO_SUSPEND:
								GetAttr(GA_Selected, suspend, (ULONG *)&val);
								qi->Suspend = (BOOL)val;
								break;
							case GAD_QUEUEINFO_SCHEDTYPE:
								GetAttr(CHOOSER_Active, schedtype, (ULONG *)&val);
								qi->Type = (BYTE)val;
								break;
							case GAD_QUEUEINFO_WHEN:
								GetAttr(STRINGA_TextVal, when, (ULONG *)&text);
								if(text)
									strncpy(qi->Date, text, sizeof(qi->Date) - 1);
								break;
							case GAD_QUEUEINFO_OKAY:
								done = TRUE;
								break;
						}
						break;
				}
			}
		}
	}

	thatsit:
	if(winobj)
		DisposeObject(winobj);

	if(sched_types)
		FreeChooserLabels(sched_types);

#endif

	return qi;
}

QueueInfo *queueinfo_new(void)
{
	QueueInfo *qi = NULL;
	
	
	
	return qi;
}

void queueinfo_free(QueueInfo *qi)
{
	if(qi)
	{


		g_free(qi);
	}
}

gboolean compose_get_tagline(Composition *comp)
{
	GList *node;
	glong count;
	gboolean success = TRUE;

	if(!*uprefs.Taglines)
		return FALSE;

	/* Check if there are any.
	 */
	if(!g_list_length(euc.Taglines.List))
	{
		gchar text[4096];
		FILE *fp;
		
		if(fp = fopen(uprefs.Taglines, "r"))
		{
			while(fgets(text, sizeof(text) - 1, fp))
			{
				gchar *c, *str;

				if(c = strchr(text, '\r'))
					*c = '\0';
				if(c = strchr(text, '\n'))
					*c = '\0';

				str = g_strdup(text);
				list_append(&euc.Taglines, str);
			}

			fclose(fp);
		}
	}

	srand(time(NULL));

	if(count = g_list_length(euc.Taglines.List))
	{
		gchar *str;
		
		if(str = g_list_nth_data(euc.Taglines.List, rand() % count))
		{
			strncpy(comp->t.Tagline, str, sizeof(comp->t.Tagline) - 1);
			
			gtk_entry_set_text(GTK_ENTRY(comp->w.Tagline), comp->t.Tagline);
		}
		else
			success = FALSE;
	}
	else
		success = FALSE;

	return success;
}

GList *compose_parse_addresses(Composition *comp, gchar type)
{
	GList *list = NULL;
	gchar *addrs, *p;

	switch(type)
	{
		case CAT_TO:
		default:
			addrs = gtk_editable_get_chars(GTK_EDITABLE(comp->w.AddrTo), 0, -1);
			break;
			
		case CAT_CC:
			addrs = gtk_editable_get_chars(GTK_EDITABLE(comp->w.AddrCc), 0, -1);
			break;
			
		case CAT_BCC:
			addrs = gtk_editable_get_chars(GTK_EDITABLE(comp->w.AddrBcc), 0, -1);
			break;
	}
	
	if(*addrs)
	{
		p = addrs;
		for(;;)
		{
			gchar *c;
			
			c = strchr(p, ';');
			if(c)
				*c = 0;

			list = g_list_append(list, g_strdup(p));
			
			if(!c)
				break;
				
			p = c + 1;
		}
	}
	
	g_free(addrs);

	return list;
}
