#ifndef EUCALYPTUS_DEFINES_H
#define EUCALYPTUS_DEFINES_H

/*
 * Eucalyptus
 * by Paul A. Schifferer
 *
 * Header: defines.h
 *   	 Global definitions
 *
 * Copyright  1997-9 Isengard Developments
 * All rights reserved.
 */

/* Misc definitions
 */
#define EUCALYPTUSSTACKSIZE   	(16000)
#define EUCALYPTUS_MAGIC 		(11195)

#define WORKLEN				(4096)
#define FOLDERINDEX_BUFSIZE   	(100)

#define EUCALYPTUS_FORMS_DIR		"Forms"
#define FOLDERINFO_FILE			"FOLDERS"
#define FOLDERDATA_FILE			"FOLDER"
#define INDEX_FILE				"INDEX"

/* Function parameter values, etc.
 */
#define MSGPART_ALL 	(1)

#define AEG_ROOT    	((AddressEntry *)1)

#define PASSWORDCHAR		'*'

// for UUde/encoding
#define DEC(c) (((c) - ' ') & 077)
#define ENC(c) (((c) & 077) + ' ')

// flags for CompactHeaderText()
#define CHTF_LEAVECOMMENTS    	(1 << 0)
#define CHTF_LEAVEWHITESPACE  	(1 << 1)
#define CHTF_CASECONV    		(1 << 2)

// RequestString flags
#define RSF_PASSWORD			(1 << 0)

// SelectFolder flags
#define SFF_INCLUDEPOSTPONED  	(1L << 0)
#define SFF_ROOT    			(1L << 1)

// GetPrintOptions flags

// SelectAddress flags
#define SAF_ONE				(1 << 0)

// FolderMarkMsgs types
#define FMMF_READ   			(0)
#define FMMF_UNREAD 			(1)
#define FMMF_IMPORTANT   		(2)

// BuildAddressBook flags
#define BABF_KEEPSEL			(1 << 0)
#define BABF_COLUMNS			(1 << 1)

/* SelectFolder.why values.
 */
enum
{
	SELECT_FOLDER_COPY=1,
	SELECT_FOLDER_MOVE,
	SELECT_FOLDER_INFO
};

#define DEFAULT_WINDOW_WIDTH		(600)
#define DEFAULT_WINDOW_HEIGHT		(350)

#define DEFAULT_FOLDER_WINDOW_WIDTH	DEFAULT_WINDOW_WIDTH
#define DEFAULT_FOLDER_WINDOW_HEIGHT	DEFAULT_WINDOW_HEIGHT

#define DEFAULT_MSG_WINDOW_WIDTH		DEFAULT_WINDOW_WIDTH
#define DEFAULT_MSG_WINDOW_HEIGHT		DEFAULT_WINDOW_HEIGHT

#define DEFAULT_COMPOSE_WINDOW_WIDTH	(500)
#define DEFAULT_COMPOSE_WINDOW_HEIGHT	(400)

#define DEFAULT_SMTP_WINDOW_WIDTH		(300)
#define DEFAULT_SMTP_WINDOW_HEIGHT		(200)

#define DEFAULT_POP_WINDOW_WIDTH		(300)
#define DEFAULT_POP_WINDOW_HEIGHT		(200)

#define DEFAULT_ADDRBOOK_WINDOW_WIDTH	DEFAULT_WINDOW_WIDTH
#define DEFAULT_ADDRBOOK_WINDOW_HEIGHT	DEFAULT_WINDOW_HEIGHT

#endif /* EUCALYPTUS_DEFINES_H */
