/*
 * Eucalyptus
 * by Paul A. Schifferer
 *
 * Module: gui_menus.c
 *   	 Menu data structures
 *
 * Copyright  1997-9 Isengard Developments
 * All rights reserved.
 */

#include <libgnomeui/gnome-app.h>
#include <libgnomeui/gnome-app-helper.h>

#include "eucalyptus.h"

/* Folder menu structures.
 */
GnomeUIInfo folder_sort_radio_items[] =
{
	{ GNOME_APP_UI_ITEM, N_("Natural"), N_("Don't sort messages"), 
			folder_sort_cb, NULL, NULL, 0, 0,
			'0', GDK_CONTROL_MASK, NULL, },
	{ GNOME_APP_UI_ITEM, N_("By date"), N_("Sort by date header"), 
			folder_sort_cb, NULL, NULL, 0, 0,
			'1', GDK_CONTROL_MASK, NULL, },
	{ GNOME_APP_UI_ITEM, N_("By name"), N_("Sort alphabetically by name"), 
			folder_sort_cb, NULL, NULL, 0, 0,
			'2', GDK_CONTROL_MASK, NULL, },
	{ GNOME_APP_UI_ITEM, N_("By subject"), N_("Sort alphabetically by subject"), 
			folder_sort_cb, NULL, NULL, 0, 0,
			'3', GDK_CONTROL_MASK, NULL, },
	{ GNOME_APP_UI_ITEM, N_("By size"), N_("Sort from smallest to largest"), 
			folder_sort_cb, NULL, NULL, 0, 0,
			'4', GDK_CONTROL_MASK, NULL, },
	{ GNOME_APP_UI_ITEM, N_("By status"), N_("Sort with new messages at the top"), 
			folder_sort_cb, NULL, NULL, 0, 0,
			'5', GDK_CONTROL_MASK, NULL, },
	GNOMEUIINFO_END,
};

GnomeUIInfo folder_sort_menu[] =
{
	GNOMEUIINFO_RADIOLIST(folder_sort_radio_items),
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_TOGGLEITEM, N_("Thread?"), N_("Keep messages with the same subject together"), 
			folder_sort_cb, NULL, NULL, 0, 0,
			't', GDK_CONTROL_MASK, NULL, },
	GNOMEUIINFO_END,
};

GnomeUIInfo folder_folder_menu[] =
{
	{ GNOME_APP_UI_ITEM, N_("_Check"), N_("Check the folder's spool file for new messages"), 
			folder_check_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_REFRESH,
			'k', GDK_CONTROL_MASK | GDK_MOD1_MASK, NULL, },
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("_Refresh"), N_("Rebuild the folder's message list"), 
			folder_refresh_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_REFRESH,
			'r', GDK_CONTROL_MASK | GDK_MOD1_MASK, NULL, },
	GNOMEUIINFO_SUBTREE(N_("Sort"), folder_sort_menu),
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("_Import..."), N_("Import messages to this folder"), 
			folder_import_cb, NULL, NULL, 0, 0,
			'i', GDK_CONTROL_MASK, NULL, },
	{ GNOME_APP_UI_ITEM, N_("_Apply filters..."), N_("Apply filters against the contents of this folder"), 
			folder_apply_filters_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_BOOK_OPEN,
			'a', GDK_CONTROL_MASK, NULL, },
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("E_xpunge deleted"), N_("Removed deleted messages from this folder"), 
			folder_expunge_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_TRASH,
			'x', GDK_CONTROL_MASK, NULL, },
	GNOMEUIINFO_SEPARATOR,
	GNOMEUIINFO_MENU_CLOSE_ITEM(folder_close_cb, NULL),
	GNOMEUIINFO_END,
};

GnomeUIInfo folder_folder_menu_postponed[] =
{
	{ GNOME_APP_UI_ITEM, N_("_Refresh"), N_("Rebuild the folder's message list"), 
			folder_refresh_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_REFRESH,
			'r', GDK_CONTROL_MASK | GDK_MOD1_MASK, NULL, },
	GNOMEUIINFO_SUBTREE(N_("Sort"), folder_sort_menu),
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("E_xpunge deleted"), N_("Removed deleted messages from this folder"), 
			folder_expunge_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_TRASH,
			'x', GDK_CONTROL_MASK, NULL, },
	GNOMEUIINFO_SEPARATOR,
	GNOMEUIINFO_MENU_CLOSE_ITEM(folder_close_cb, NULL),
	GNOMEUIINFO_END,
};

GnomeUIInfo folder_folder_menu_outgoing_sent[] =
{
	{ GNOME_APP_UI_ITEM, N_("_Refresh"), N_("Rebuild the folder's message list"), 
			folder_refresh_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_REFRESH,
			'r', GDK_CONTROL_MASK | GDK_MOD1_MASK, NULL, },
	GNOMEUIINFO_SUBTREE(N_("Sort"), folder_sort_menu),
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("E_xpunge deleted"), N_("Removed deleted messages from this folder"), 
			folder_expunge_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_TRASH,
			'x', GDK_CONTROL_MASK, NULL, },
	GNOMEUIINFO_SEPARATOR,
	GNOMEUIINFO_MENU_CLOSE_ITEM(folder_close_cb, NULL),
	GNOMEUIINFO_END,
};

GnomeUIInfo folder_reply_menu[] =
{
	{ GNOME_APP_UI_ITEM, N_("_Sender"), N_("Reply to the sender of the selected message(s)"), 
			folder_reply_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_MAIL_RPL,
			'r', GDK_CONTROL_MASK, NULL, },
	{ GNOME_APP_UI_ITEM, N_("_All"), N_("Reply to all addresses of the selected message(s)"), 
			folder_reply_all_cb, NULL, NULL, 0, 0,
			'a', GDK_CONTROL_MASK | GDK_MOD1_MASK, NULL, },
	{ GNOME_APP_UI_ITEM, N_("Reply, no text"), N_("Reply (without quoting) to the sender of the selected message(s)"), 
			folder_reply_notext_cb, NULL, NULL, 0, 0,
			0, 0, NULL, },
	{ GNOME_APP_UI_ITEM, N_("_All, no text"), N_("Reply (without quoting) to all addresses of the selected message(s)"), 
			folder_reply_all_notext_cb, NULL, NULL, 0, 0,
			0, 0, NULL, },
	GNOMEUIINFO_END,
};

GnomeUIInfo folder_forward_menu[] =
{
	{ GNOME_APP_UI_ITEM, N_("_None"), N_("Forward the selected message(s)"), 
			folder_forward_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_MAIL_FWD,
			'f', GDK_CONTROL_MASK, NULL, },
	{ GNOME_APP_UI_ITEM, N_("_Brief"), N_("Forward (with some headers) the selected message(s)"), 
			folder_forward_brief_cb, NULL, NULL, 0, 0,
			0, 0, NULL, },
	{ GNOME_APP_UI_ITEM, N_("_Full"), N_("Forward (with all headers) the selected message(s)"), 
			folder_forward_full_cb, NULL, NULL, 0, 0,
			0, 0, NULL, },
	GNOMEUIINFO_END,
};

GnomeUIInfo folder_select_menu[] =
{
	{ GNOME_APP_UI_ITEM, N_("_Some"), N_("Select messages in this folder"), 
			folder_select_cb, NULL, NULL, 0, 0,
			's', GDK_CONTROL_MASK, NULL, },
	{ GNOME_APP_UI_ITEM, N_("_All"), N_("Select all messages in this folder"), 
			folder_select_all_cb, NULL, NULL, 0, 0,
			0, 0, NULL, },
	GNOMEUIINFO_END,
};

GnomeUIInfo folder_status_menu[] =
{
	{ GNOME_APP_UI_ITEM, N_("_Read"), N_("Clear the new/unread flag on the selected message(s)"), 
			folder_status_read_cb, NULL, NULL, 0, 0,
			0, 0, NULL, },
	{ GNOME_APP_UI_ITEM, N_("_Unread"), N_("Set the unread flag on the selected message(s)"), 
			folder_status_unread_cb, NULL, NULL, 0, 0,
			0, 0, NULL, },
	{ GNOME_APP_UI_ITEM, N_("_Important"), N_("Set the important flag on the selected message(s)"), 
			folder_status_important_cb, NULL, NULL, 0, 0,
			0, 0, NULL, },
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("All read"), N_("Clear the new/unread flag on all messages"), 
			folder_status_read_all_cb, NULL, NULL, 0, 0,
			0, 0, NULL, },
	{ GNOME_APP_UI_ITEM, N_("All unread"), N_("Mark all messages unread"), 
			folder_status_unread_all_cb, NULL, NULL, 0, 0,
			0, 0, NULL, },
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("_Set..."), N_("Set status flags on selected message(s)"), 
			folder_status_set_cb, NULL, NULL, 0, 0,
			'u', GDK_CONTROL_MASK | GDK_MOD1_MASK, NULL, },
	GNOMEUIINFO_END,
};

GnomeUIInfo folder_msg_menu[] =
{
	{ GNOME_APP_UI_ITEM, N_("_Read..."), N_("Read the selected message(s)"), 
			folder_read_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_BOOK_OPEN,
			'o', GDK_CONTROL_MASK, NULL, },
	GNOMEUIINFO_SEPARATOR,
	GNOMEUIINFO_SUBTREE(N_("Reply"), folder_reply_menu),
	GNOMEUIINFO_SUBTREE(N_("Forward"), folder_forward_menu),
	{ GNOME_APP_UI_ITEM, N_("_Bounce..."), N_("Resend the selected message(s)"), 
			folder_bounce_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_MAIL,
			'b', GDK_CONTROL_MASK, NULL, },
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("_Print..."), N_("Print the selected message(s)"), 
			folder_print_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_PRINT,
			'p', GDK_CONTROL_MASK, NULL, },
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("_Delete..."), N_("Mark the selected message(s) for deletion"), 
			folder_delete_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_TRASH,
			'd', GDK_CONTROL_MASK, NULL, },
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("Mo_ve..."), N_("Move the selected message(s) to another folder"), 
			folder_move_cb, NULL, NULL, 0, 0,
			'v', GDK_CONTROL_MASK, NULL, },
	{ GNOME_APP_UI_ITEM, N_("Cop_y..."), N_("Copy the selected message(s) to another folder"), 
			folder_copy_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_COPY,
			'y', GDK_CONTROL_MASK, NULL, },
	{ GNOME_APP_UI_ITEM, N_("Export..."), N_("Export selected message(s)"), 
			folder_export_cb, NULL, NULL, 0, 0,
			'e', GDK_CONTROL_MASK | GDK_MOD1_MASK, NULL, },
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("_Get address..."), N_("Add the selected message(s) address(es) to the address book"), 
			folder_get_addr_cb, NULL, NULL, 0, 0,
			'g', GDK_CONTROL_MASK | GDK_MOD1_MASK, NULL, },
	GNOMEUIINFO_SEPARATOR,
	GNOMEUIINFO_SUBTREE(N_("Select"), folder_select_menu),
	GNOMEUIINFO_SUBTREE(N_("Status"), folder_status_menu),
	GNOMEUIINFO_END,
};

GnomeUIInfo folder_msg_menu_postponed[] =
{
	{ GNOME_APP_UI_ITEM, N_("_Resume..."), N_("Continue editing the selected message(S)"), 
			folder_resume_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_MAIL,
			'o', GDK_CONTROL_MASK, NULL, },
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("_Delete..."), N_("Mark the selected message(s) for deletion"), 
			folder_delete_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_TRASH,
			'd', GDK_CONTROL_MASK, NULL, },
	GNOMEUIINFO_END,
};

GnomeUIInfo folder_msg_menu_outgoing[] =
{
	{ GNOME_APP_UI_ITEM, N_("_Read..."), N_("Read the selected message(s)"), 
			folder_read_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_BOOK_OPEN,
			'o', GDK_CONTROL_MASK, NULL, },
	{ GNOME_APP_UI_ITEM, N_("_Edit..."), N_("Modify the selected message(s)"), 
			folder_edit_cb, NULL, NULL, 0, 0,
			'e', GDK_CONTROL_MASK, NULL, },
	{ GNOME_APP_UI_ITEM, N_("_Send"), N_("Send the selected message(s)"), 
			folder_send_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_MAIL_SND,
			's', GDK_CONTROL_MASK, NULL, },
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("_Print..."), N_("Print the selected message(s)"), 
			folder_print_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_PRINT,
			'p', GDK_CONTROL_MASK, NULL, },
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("_Delete..."), N_("Mark the selected message(s) for deletion"), 
			folder_delete_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_TRASH,
			'd', GDK_CONTROL_MASK, NULL, },
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("Mo_ve..."), N_("Move the selected message(s) to another folder"), 
			folder_move_cb, NULL, NULL, 0, 0,
			'v', GDK_CONTROL_MASK, NULL, },
	{ GNOME_APP_UI_ITEM, N_("Cop_y..."), N_("Copy the selected message(s) to another folder"), 
			folder_copy_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_COPY,
			'y', GDK_CONTROL_MASK, NULL, },
	{ GNOME_APP_UI_ITEM, N_("Export..."), N_("Export selected message(s)"), 
			folder_export_cb, NULL, NULL, 0, 0,
			'e', GDK_CONTROL_MASK | GDK_MOD1_MASK, NULL, },
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("_Get address..."), N_("Add the selected message(s) address(es) to the address book"), 
			folder_get_addr_cb, NULL, NULL, 0, 0,
			'g', GDK_CONTROL_MASK | GDK_MOD1_MASK, NULL, },
	GNOMEUIINFO_SEPARATOR,
	GNOMEUIINFO_SUBTREE(N_("Select"), folder_select_menu),
	GNOMEUIINFO_SUBTREE(N_("Status"), folder_status_menu),
	GNOMEUIINFO_END,
};

GnomeUIInfo folder_msg_menu_sent[] =
{
	{ GNOME_APP_UI_ITEM, N_("_Read..."), N_("Read the selected message(s)"), 
			folder_read_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_BOOK_OPEN,
			'o', GDK_CONTROL_MASK, NULL, },
	{ GNOME_APP_UI_ITEM, N_("_Send again"), N_("Send the selected message(s)"), 
			folder_send_again_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_MAIL_SND,
			's', GDK_CONTROL_MASK, NULL, },
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("_Print..."), N_("Print the selected message(s)"), 
			folder_print_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_PRINT,
			'p', GDK_CONTROL_MASK, NULL, },
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("_Delete..."), N_("Mark the selected message(s) for deletion"), 
			folder_delete_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_TRASH,
			'd', GDK_CONTROL_MASK, NULL, },
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("Export..."), N_("Export selected message(s)"), 
			folder_export_cb, NULL, NULL, 0, 0,
			'e', GDK_CONTROL_MASK | GDK_MOD1_MASK, NULL, },
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("_Get address..."), N_("Add the selected message(s) address(es) to the address book"), 
			folder_get_addr_cb, NULL, NULL, 0, 0,
			'g', GDK_CONTROL_MASK | GDK_MOD1_MASK, NULL, },
	GNOMEUIINFO_SEPARATOR,
	GNOMEUIINFO_SUBTREE(N_("Select"), folder_select_menu),
	GNOMEUIINFO_END,
};

GnomeUIInfo folder_help_menu[] =
{
	GNOMEUIINFO_HELP("Eucalyptus"),
	GNOMEUIINFO_SEPARATOR,
	GNOMEUIINFO_MENU_ABOUT_ITEM(euc_about_requested_cb, NULL),
	GNOMEUIINFO_END,
};

GnomeUIInfo folder_menu[] =
{
	GNOMEUIINFO_SUBTREE(N_("_Folder"), folder_folder_menu),
	GNOMEUIINFO_SUBTREE(N_("_Message"), folder_msg_menu),
	GNOMEUIINFO_MENU_HELP_TREE(folder_help_menu),
	GNOMEUIINFO_END,
};

GnomeUIInfo folder_menu_postponed[] =
{
	GNOMEUIINFO_SUBTREE(N_("_Folder"), folder_folder_menu_postponed),
	GNOMEUIINFO_SUBTREE(N_("_Message"), folder_msg_menu_postponed),
	GNOMEUIINFO_MENU_HELP_TREE(folder_help_menu),
	GNOMEUIINFO_END,
};

GnomeUIInfo folder_menu_outgoing[] =
{
	GNOMEUIINFO_SUBTREE(N_("_Folder"), folder_folder_menu_outgoing_sent),
	GNOMEUIINFO_SUBTREE(N_("_Message"), folder_msg_menu_outgoing),
	GNOMEUIINFO_MENU_HELP_TREE(folder_help_menu),
	GNOMEUIINFO_END,
};

GnomeUIInfo folder_menu_sent[] =
{
	GNOMEUIINFO_SUBTREE(N_("_Folder"), folder_folder_menu_outgoing_sent),
	GNOMEUIINFO_SUBTREE(N_("_Message"), folder_msg_menu_sent),
	GNOMEUIINFO_MENU_HELP_TREE(folder_help_menu),
	GNOMEUIINFO_END,
};

/* Message menu structures.
 */
GnomeUIInfo mailmsg_reply_submenu[] =
{
	{ GNOME_APP_UI_ITEM, N_("_Sender"), N_(""), 
			mailmsg_reply_cb, NULL, NULL,
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_MAIL_RPL,
			'r', GDK_CONTROL_MASK, NULL, },
	{ GNOME_APP_UI_ITEM, N_("_All"), N_(""), 
			mailmsg_reply_all_cb, NULL, NULL, 0, 0,
			0, GDK_CONTROL_MASK, NULL, },
	{ GNOME_APP_UI_ITEM, N_("Sender, no text"), N_(""), 
			mailmsg_reply_none_cb, NULL, NULL, 0, 0,
			0, GDK_CONTROL_MASK, NULL, },
	{ GNOME_APP_UI_ITEM, N_("All, no text"), N_(""), 
			mailmsg_reply_all_none_cb, NULL, NULL, 0, 0,
			0, GDK_CONTROL_MASK, NULL, },
	GNOMEUIINFO_END,
};

GnomeUIInfo mailmsg_forward_submenu[] =
{
	{ GNOME_APP_UI_ITEM, N_("_Message"), N_(""), 
			mailmsg_forward_cb, NULL, NULL,
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_MAIL_FWD,
			'f', GDK_CONTROL_MASK, NULL, },
	{ GNOME_APP_UI_ITEM, N_("_Brief"), N_(""), 
			mailmsg_forward_some_cb, NULL, NULL, 0, 0,
			0, GDK_CONTROL_MASK, NULL, },
	{ GNOME_APP_UI_ITEM, N_("_All headers"), N_(""), 
			mailmsg_forward_all_cb, NULL, NULL, 0, 0,
			0, GDK_CONTROL_MASK, NULL, },
	GNOMEUIINFO_END,
};

GnomeUIInfo mailmsg_status_submenu[] =
{
	{ GNOME_APP_UI_ITEM, N_("_Read"), N_(""), 
			mailmsg_status_read_cb, NULL, NULL, 0, 0,
			0, GDK_CONTROL_MASK, NULL, },
	{ GNOME_APP_UI_ITEM, N_("_Unread"), N_(""), 
			mailmsg_status_unread_cb, NULL, NULL, 0, 0,
			0, GDK_CONTROL_MASK, NULL, },
	{ GNOME_APP_UI_ITEM, N_("_Important"), N_(""), 
			mailmsg_status_important_cb, NULL, NULL, 0, 0,
			0, GDK_CONTROL_MASK, NULL, },
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("_Set..."), N_(""), 
			mailmsg_status_set_cb, NULL, NULL, 0, 0,
			's', GDK_CONTROL_MASK, NULL, },
	GNOMEUIINFO_END,
};

GnomeUIInfo mailmsg_msg_menu[] =
{
	{ GNOME_APP_UI_ITEM, N_("_Compose"), N_(""), 
			mailmsg_compose_cb, NULL, NULL,
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_MAIL_NEW,
			'c', GDK_CONTROL_MASK, NULL, },
	GNOMEUIINFO_SUBTREE(N_("_Reply"), mailmsg_reply_submenu),
	GNOMEUIINFO_SUBTREE(N_("_Forward"), mailmsg_forward_submenu),
	{ GNOME_APP_UI_ITEM, N_("_Bounce"), N_(""), 
			mailmsg_bounce_cb, NULL, NULL, 0, 0,
			'b', GDK_CONTROL_MASK, NULL, },
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("_Print"), N_(""), 
			mailmsg_print_cb, NULL, NULL,
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_PRINT,
			'p', GDK_CONTROL_MASK, NULL, },
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("_Delete"), N_(""), 
			mailmsg_delete_cb, NULL, NULL,
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_REMOVE,
			'd', GDK_CONTROL_MASK, NULL, },
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("_Move"), N_(""), 
			mailmsg_move_cb, NULL, NULL, 0, 0,
			'v', GDK_CONTROL_MASK, NULL, },
	{ GNOME_APP_UI_ITEM, N_("_Copy"), N_(""), 
			mailmsg_copy_cb, NULL, NULL, 0, 0,
			'y', GDK_CONTROL_MASK, NULL, },
	{ GNOME_APP_UI_ITEM, N_("_Export"), N_(""), 
			mailmsg_export_cb, NULL, NULL, 0, 0,
			'x', GDK_CONTROL_MASK, NULL, },
	GNOMEUIINFO_SEPARATOR,
	GNOMEUIINFO_SUBTREE(N_("_Status"), mailmsg_status_submenu),
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("_Previous"), N_(""), 
			mailmsg_prev_msg_cb, NULL, NULL,
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_BACK,
			'<', GDK_CONTROL_MASK, NULL, },
	{ GNOME_APP_UI_ITEM, N_("_Next"), N_(""), 
			mailmsg_next_msg_cb, NULL, NULL,
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_FORWARD,
			'>', GDK_CONTROL_MASK, NULL, },
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("Close"), N_(""), 
			mailmsg_close_cb, NULL, NULL,
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_EXIT,
			'q', GDK_CONTROL_MASK, NULL, },
	GNOMEUIINFO_END,
};

GnomeUIInfo mailmsg_contents_menu[] =
{
	{ GNOME_APP_UI_ITEM, N_("_Get address"), N_(""), 
			mailmsg_get_addr_cb, NULL, NULL,
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_BOOK_OPEN,
			'g', GDK_CONTROL_MASK, NULL, },
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("_Save text"), N_(""), 
			mailmsg_save_cb, NULL, NULL,
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_SAVE,
			's', GDK_CONTROL_MASK, NULL, },
	{ GNOME_APP_UI_ITEM, N_("Save _attachment"), N_(""), 
			mailmsg_save_attach_cb, NULL, NULL, 0, 0,
			'a', GDK_CONTROL_MASK, NULL, },
	{ GNOME_APP_UI_ITEM, N_("Save _message"), N_(""), 
			mailmsg_save_raw_cb, NULL, NULL, 0, 0,
			's', GDK_CONTROL_MASK | GDK_MOD1_MASK, NULL, },
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("_UUdecode"), N_(""), 
			mailmsg_uudecode_cb, NULL, NULL, 0, 0,
			'u', GDK_CONTROL_MASK, NULL, },
	GNOMEUIINFO_END,
};

GnomeUIInfo mailmsg_security_menu[] =
{
	{ GNOME_APP_UI_ITEM, N_("_Check signature"), N_(""), 
			mailmsg_check_sig_cb, NULL, NULL, 0, 0,
			'c', GDK_CONTROL_MASK | GDK_MOD1_MASK, NULL, },
	{ GNOME_APP_UI_ITEM, N_("_Decrypt"), N_(""), 
			mailmsg_decrypt_cb, NULL, NULL, 0, 0,
			'd', GDK_CONTROL_MASK | GDK_MOD1_MASK, NULL, },
	{ GNOME_APP_UI_ITEM, N_("_Extract key"), N_(""), 
			mailmsg_extract_key_cb, NULL, NULL, 0, 0,
			'k', GDK_CONTROL_MASK | GDK_MOD1_MASK, NULL, },
	GNOMEUIINFO_END,
};

GnomeUIInfo mailmsg_help_menu[] =
{
	GNOMEUIINFO_HELP("Eucalyptus"),
	GNOMEUIINFO_SEPARATOR,
	GNOMEUIINFO_MENU_ABOUT_ITEM(euc_about_requested_cb, NULL),
	GNOMEUIINFO_END,
};

GnomeUIInfo mailmsg_menu[] =
{
	GNOMEUIINFO_SUBTREE(N_("_Message"), mailmsg_msg_menu),
	GNOMEUIINFO_SUBTREE(N_("_Contents"), mailmsg_contents_menu),
	GNOMEUIINFO_SUBTREE(N_("_Security"), mailmsg_security_menu),
	GNOMEUIINFO_MENU_HELP_TREE(mailmsg_help_menu),
	GNOMEUIINFO_END,
};


/* Compose menu stuctures.
 */
GnomeUIInfo compose_compose_menu[] =
{
	{ GNOME_APP_UI_ITEM, N_("_Send"), N_("Send this message"), 
			compose_send_cb, NULL, NULL,
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_MAIL_SND,
			's', GDK_CONTROL_MASK, NULL, },
	{ GNOME_APP_UI_ITEM, N_("_Queue"), N_("Queue this message to send later"), 
			compose_queue_cb, NULL, NULL, 0, 0,
			'q', GDK_CONTROL_MASK | GDK_MOD1_MASK, NULL, },
	{ GNOME_APP_UI_ITEM, N_("_Postpone"), N_("Save a draft of this message to edit later"), 
			compose_postpone_cb, NULL, NULL, 0, 0,
			'p', GDK_CONTROL_MASK, NULL, },
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("Cancel"), N_("Cancel this message"), 
			compose_cancel_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_QUIT,
			'q', GDK_CONTROL_MASK, NULL, },
	GNOMEUIINFO_END,
};

GnomeUIInfo compose_insert_menu[] =
{
	{ GNOME_APP_UI_ITEM, N_("_File"), N_("Insert a file"), 
			compose_insert_file_cb, NULL, NULL,
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_ADD,
			'f', GDK_CONTROL_MASK, NULL, },
	{ GNOME_APP_UI_ITEM, N_("Bracketed"), N_("Insert a file with bracketing"), 
			compose_insert_file_bracketed_cb, NULL, NULL, 0, 0,
			0, 0, NULL, },
	{ GNOME_APP_UI_ITEM, N_("Indented"), N_("Insert a file with indentation"), 
			compose_insert_file_indented_cb, NULL, NULL, 0, 0,
			0, 0, NULL, },
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("Form"), N_("Insert a form"), 
			compose_insert_form_cb, NULL, NULL, 0, 0,
			0, 0, NULL, },
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("UUencoded"), N_("Insert and UUencode a file"), 
			compose_insert_file_uuencoded_cb, NULL, NULL, 0, 0,
			0, 0, NULL, },
	GNOMEUIINFO_END,
};

GnomeUIInfo compose_edit_menu[] =
{
#if 0
	{ GNOME_APP_UI_ITEM, N_("_Undo"), N_("Undo the last edit"), 
			compose_undo_cb, NULL, NULL,
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_UNDO,
			'u', GDK_CONTROL_MASK, NULL, },
	{ GNOME_APP_UI_ITEM, N_("_Redo"), N_("Redo the last undo"), 
			compose_redo_cb, NULL, NULL,
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_REDO,
			'z', GDK_CONTROL_MASK, NULL, },
	GNOMEUIINFO_SEPARATOR,
#endif
	{ GNOME_APP_UI_ITEM, N_("_Cut"), N_("Cut the selected block"), 
			compose_cut_cb, NULL, NULL,
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_CUT,
			'x', GDK_CONTROL_MASK, NULL, },
	{ GNOME_APP_UI_ITEM, N_("Cop_y"), N_("Copy the selected block"), 
			compose_copy_cb, NULL, NULL,
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_COPY,
			'c', GDK_CONTROL_MASK, NULL, },
	{ GNOME_APP_UI_ITEM, N_("_Paste"), N_("Paste the clipboard"), 
			compose_paste_cb, NULL, NULL,
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_PASTE,
			'v', GDK_CONTROL_MASK, NULL, },
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("_Erase"), N_("Erase the selected block"), 
			compose_erase_cb, NULL, NULL,
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_REMOVE,
			'e', GDK_CONTROL_MASK, NULL, },
	{ GNOME_APP_UI_ITEM, N_("C_lear"), N_("Clear the entire text"), 
			compose_clear_cb, NULL, NULL,
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_CLEAR,
			'e', GDK_CONTROL_MASK | GDK_MOD1_MASK, NULL, },
	GNOMEUIINFO_SEPARATOR,
	GNOMEUIINFO_SUBTREE(N_("Insert file"), compose_insert_menu),
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("Save"), N_("Save the text to a file"), 
			compose_save_cb, NULL, NULL,
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_SAVE,
			's', GDK_CONTROL_MASK | GDK_MOD1_MASK, NULL, },
	GNOMEUIINFO_END,
};

#ifdef COMPOSE_STYLE_MENU
GnomeUIInfo compose_style_menu[] =
{
	{ GNOME_APP_UI_ITEM, N_("_Plain"), N_("Select plain text style"), 
			compose_plain_cb, NULL, NULL, 0, 0,
			'0', GDK_CONTROL_MASK, NULL, },
	{ GNOME_APP_UI_ITEM, N_("_Bold"), N_("Select bold text style"), 
			compose_bold_cb, NULL, NULL,
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_TEXT_BOLD,
			'1', GDK_CONTROL_MASK, NULL, },
	{ GNOME_APP_UI_ITEM, N_("_Italic"), N_("Select italic text style"), 
			compose_italic_cb, NULL, NULL,
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_TEXT_ITALIC,
			'2', GDK_CONTROL_MASK, NULL, },
	{ GNOME_APP_UI_ITEM, N_("_Underline"), N_("Select underline text style"), 
			compose_underline_cb, NULL, NULL,
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_TEXT_UNDERLINE,
			'3', GDK_CONTROL_MASK, NULL, },
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("_Color"), N_("Select a color"), 
			compose_select_color_cb, NULL, NULL, 0, 0, 
			'4', GDK_CONTROL_MASK, NULL, },
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("Left-justify"), N_("Left align text"), 
			compose_left_align_cb, NULL, NULL,
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_ALIGN_LEFT,
			'[', GDK_MOD1_MASK, NULL, },
	{ GNOME_APP_UI_ITEM, N_("Center"), N_("Center text"), 
			compose_center_align_cb, NULL, NULL,
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_ALIGN_CENTER,
			'|', GDK_MOD1_MASK, NULL, },
	{ GNOME_APP_UI_ITEM, N_("Right-justify"), N_("Right align text"), 
			compose_right_align_cb, NULL, NULL,
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_ALIGN_RIGHT,
			']', GDK_MOD1_MASK, NULL, },
	GNOMEUIINFO_END,
};
#endif

GnomeUIInfo compose_misc_menu[] =
{
	{ GNOME_APP_UI_ITEM, N_("Check spelling"), N_("Check spelling for this message"), 
			compose_spellcheck_cb, NULL, NULL,
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_SPELLCHECK,
			'k', GDK_CONTROL_MASK, NULL, },
	{ GNOME_APP_UI_ITEM, N_("Check definition"), N_("Check definition for one or more words"), 
			compose_defcheck_cb, NULL, NULL,
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_SPELLCHECK,
			'k', GDK_CONTROL_MASK | GDK_MOD1_MASK, NULL, },
	GNOMEUIINFO_END,
};

GnomeUIInfo compose_help_menu[] =
{
	GNOMEUIINFO_HELP("Eucalyptus"),
	GNOMEUIINFO_SEPARATOR,
	GNOMEUIINFO_MENU_ABOUT_ITEM(euc_about_requested_cb, NULL),
	GNOMEUIINFO_END,
};

GnomeUIInfo compose_menu[] =
{
	GNOMEUIINFO_SUBTREE(N_("_Compose"), compose_compose_menu),
	GNOMEUIINFO_SUBTREE(N_("_Edit"), compose_edit_menu),
#ifdef COMPOSE_STYLE_MENU
	GNOMEUIINFO_SUBTREE(N_("_Style"), compose_style_menu),
#endif
	GNOMEUIINFO_SUBTREE(N_("_Misc."), compose_misc_menu),
	GNOMEUIINFO_MENU_HELP_TREE(compose_help_menu),
	GNOMEUIINFO_END,
};

/* Common main menu structures.
 */
GnomeUIInfo main_compose_submenu[] =
{
	{ GNOME_APP_UI_ITEM, N_("_Message..."), N_("Compose a mail message"), 
			euc_open_compose_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_MAIL_NEW,
			'm', GDK_CONTROL_MASK, NULL, },
	{ GNOME_APP_UI_ITEM, N_("_From form..."), N_("Selects a composition template"), 
			euc_open_compose_form_cb, NULL, NULL, 0, 0,
			'f', GDK_CONTROL_MASK | GDK_MOD1_MASK, NULL, },
	{ GNOME_APP_UI_ITEM, N_("From _address book..."), N_("Selects an address to send to"), 
			euc_open_compose_addr_cb, NULL, NULL, 0, 0,
			'a', GDK_CONTROL_MASK | GDK_MOD1_MASK, NULL, },
	{ GNOME_APP_UI_ITEM, N_("_Bug report..."), N_("Submit a bug report"), 
			euc_bug_report_cb, NULL, NULL, 0, 0,
			'b', GDK_CONTROL_MASK | GDK_MOD1_MASK, NULL, },
	GNOMEUIINFO_END,
};

GnomeUIInfo main_project_menu[] =
{
	GNOMEUIINFO_SUBTREE(N_("_Compose"), main_compose_submenu),
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("_Address book..."), N_("Open the address book"), 
			addresses_open_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_BOOK_OPEN,
			'a', GDK_CONTROL_MASK, NULL, },
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("_Get new mail"), N_("Retrieve mail from the mail server(s)"), 
			pop_get_new_mail_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_MAIL_RCV,
			'g', GDK_CONTROL_MASK, NULL, },
#if 0
	{ GNOME_APP_UI_ITEM, N_("Open retrieve window..."), N_("Open the mail retriever window"), 
			pop_open_retriever_cb, NULL, NULL, 0, 0,
			'p', GDK_CONTROL_MASK, NULL, },
	GNOMEUIINFO_SEPARATOR,
#endif
	{ GNOME_APP_UI_ITEM, N_("_Send mail"), N_("Send any queued messages"), 
			smtp_send_mail_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_MAIL_SND,
			's', GDK_CONTROL_MASK, NULL, },
#if 0
	{ GNOME_APP_UI_ITEM, N_("_Open send window..."), N_("Open the mail sender window"), 
			smtp_open_sender_cb, NULL, NULL, 0, 0,
			'w', GDK_CONTROL_MASK, NULL, },
#endif
	GNOMEUIINFO_SEPARATOR,
	GNOMEUIINFO_MENU_EXIT_ITEM(euc_quit_requested_cb, NULL),
	GNOMEUIINFO_END,
};

GnomeUIInfo main_help_menu[] =
{
	GNOMEUIINFO_HELP("Eucalyptus"),
	GNOMEUIINFO_SEPARATOR,
	GNOMEUIINFO_MENU_ABOUT_ITEM(euc_about_requested_cb, NULL),
	GNOMEUIINFO_END,
};

GnomeUIInfo main_macro_menu[] =
{
	{ GNOME_APP_UI_ITEM, N_("Execute macro..."), N_("Execute a macro"), 
			euc_execute_macro_cb, NULL, NULL, 0, 0,
			'm', GDK_CONTROL_MASK | GDK_MOD1_MASK, NULL, },
	GNOMEUIINFO_SEPARATOR,
	GNOMEUIINFO_END,
};

GnomeUIInfo main_settings_menu[] =
{
	{ GNOME_APP_UI_ITEM, N_("General..."), N_("Open settings panel"), 
			edit_general_prefs_cb, NULL, NULL, 0, 0,
			'1', GDK_CONTROL_MASK | GDK_MOD1_MASK, NULL, },
	{ GNOME_APP_UI_ITEM, N_("User..."), N_("Open user information panel"), 
			edit_user_prefs_cb, NULL, NULL, 0, 0,
			'2', GDK_CONTROL_MASK | GDK_MOD1_MASK, NULL, },
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("Filters..."), N_("Open filters editor"), 
			filters_edit_cb, NULL, NULL, 0, 0,
			'3', GDK_CONTROL_MASK | GDK_MOD1_MASK, NULL, },
	{ GNOME_APP_UI_ITEM, N_("Viewers..."), N_("Open viewers editor"), 
			viewers_edit_cb, NULL, NULL, 0, 0,
			'4', GDK_CONTROL_MASK | GDK_MOD1_MASK, NULL, },
	GNOMEUIINFO_END,
};

#if 0
GnomeUIInfo main_folder_list_menu[] =
{
	{ GNOME_APP_UI_ITEM, N_("_New..."), N_("Create a new folder"), 
			euc_new_folder_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_NEW,
			'n', GDK_CONTROL_MASK, NULL, },
	{ GNOME_APP_UI_ITEM, N_("_Edit..."), N_("Edit the selected folder"), 
			euc_edit_folder_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_PROPERTIES,
			'e', GDK_CONTROL_MASK, NULL, },
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("_Open..."), N_("Open the selected folder"), 
			euc_open_folder_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_OPEN,
			'o', GDK_CONTROL_MASK, NULL, },
	{ GNOME_APP_UI_ITEM, N_("_Close..."), N_("Close the selected folder"), 
			euc_close_folder_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_CLOSE,
			'c', GDK_CONTROL_MASK, NULL, },
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("_Delete..."), N_("Delete the selected folder"), 
			euc_delete_folder_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_CLEAR,
			'd', GDK_CONTROL_MASK, NULL, },
	GNOMEUIINFO_END,
};
#endif

GnomeUIInfo main_folder_menu[] =
{
	{ GNOME_APP_UI_ITEM, N_("_New..."), N_("Create a new folder"), 
			euc_new_folder_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_NEW,
			'n', GDK_CONTROL_MASK, NULL, },
	{ GNOME_APP_UI_ITEM, N_("_Edit..."), N_("Edit the selected folder"), 
			euc_edit_folder_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_PROPERTIES,
			'e', GDK_CONTROL_MASK, NULL, },
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("_Delete..."), N_("Delete the selected folder"), 
			euc_delete_folder_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_CLEAR,
			'd', GDK_CONTROL_MASK, NULL, },
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("_Check"), N_("Check the folder's spool file for new messages"), 
			folder_check_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_REFRESH,
			'k', GDK_CONTROL_MASK | GDK_MOD1_MASK, NULL, },
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("_Refresh"), N_("Rebuild the folder's message list"), 
			folder_refresh_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_REFRESH,
			'r', GDK_CONTROL_MASK | GDK_MOD1_MASK, NULL, },
	GNOMEUIINFO_SUBTREE(N_("Sort"), folder_sort_menu),
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("_Import..."), N_("Import messages to this folder"), 
			folder_import_cb, NULL, NULL, 0, 0,
			'i', GDK_CONTROL_MASK, NULL, },
	{ GNOME_APP_UI_ITEM, N_("_Apply filters..."), N_("Apply filters against the contents of this folder"), 
			folder_apply_filters_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_BOOK_OPEN,
			'a', GDK_CONTROL_MASK, NULL, },
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("E_xpunge deleted"), N_("Removed deleted messages from this folder"), 
			folder_expunge_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_TRASH,
			'x', GDK_CONTROL_MASK, NULL, },

	GNOMEUIINFO_END,
};


/* Non-integrated menu structures.
 */

/* Root menu structures.
 */
GnomeUIInfo main_menu[] =
{
	GNOMEUIINFO_SUBTREE(N_("_Project"), main_project_menu),
	GNOMEUIINFO_SUBTREE(N_("_Folders"), main_folder_menu),
//	GNOMEUIINFO_SUBTREE(N_("_Macros"), main_macro_menu),
	GNOMEUIINFO_MENU_SETTINGS_TREE(main_settings_menu),
	GNOMEUIINFO_MENU_HELP_TREE(main_help_menu),
	GNOMEUIINFO_END,
};


