/*
 * Eucalyptus
 * by Paul A. Schifferer
 *
 * Module: gui_toolbars.c
 *   	 Toolbar structures.
 *
 * Copyright  1997-9 Isengard Developments
 * All rights reserved.
 */

#include <libgnomeui/gnome-app.h>
#include <libgnomeui/gnome-app-helper.h>

#include "eucalyptus.h"

/* Main window toolbars.
 */
GnomeUIInfo main_toolbar[] =
{
	{ GNOME_APP_UI_ITEM, N_("Check"), N_("Check for new mail"), 
			pop_get_new_mail_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_MAIL_RCV,
			0, 0, NULL, },
	{ GNOME_APP_UI_ITEM, N_("Send"), N_("Send queued mail"), 
			smtp_send_mail_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_MAIL_SND,
			0, 0, NULL, },
	GNOMEUIINFO_SEPARATOR,	
	{ GNOME_APP_UI_ITEM, N_("Addresses"), N_("Open the address book"), 
			addresses_open_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_BOOK_OPEN,
			0, 0, NULL, },
	GNOMEUIINFO_SEPARATOR,	
	{ GNOME_APP_UI_ITEM, N_("Read"), N_("Read the selected message(s)"), 
			folder_read_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_BOOK_OPEN,
			0, 0, NULL, },
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("Compose"), N_("Compose a new message"), 
			folder_compose_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_MAIL_NEW,
			0, 0, NULL, },
	{ GNOME_APP_UI_ITEM, N_("Reply"), N_("Reply to the sender of the selected message(s)"), 
			folder_reply_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_MAIL_RPL,
			0, 0, NULL, },
	{ GNOME_APP_UI_ITEM, N_("Forward"), N_("Forward the selected message(s)"), 
			folder_forward_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_MAIL_FWD,
			0, 0, NULL, },
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("Print"), N_("Print the selected message(s)"), 
			folder_print_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_PRINT,
			0, 0, NULL, },
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("Delete"), N_("Mark the selected message(s) for deletion"), 
			folder_delete_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_TRASH,
			0, 0, NULL, },

	GNOMEUIINFO_END,
};

/* Folder toolbars.
 */
GnomeUIInfo folder_toolbar[] =
{
	{ GNOME_APP_UI_ITEM, N_("Check"), N_("Check the folder's spool file for new messages"), 
			folder_check_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_REFRESH,
			0, 0, NULL, },
	{ GNOME_APP_UI_ITEM, N_("Refresh"), N_("Rebuild the folder's message list"), 
			folder_refresh_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_REFRESH,
			0, 0, NULL, },
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("Read"), N_("Read the selected message(s)"), 
			folder_read_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_BOOK_OPEN,
			0, 0, NULL, },
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("Compose"), N_("Compose a new message"), 
			folder_compose_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_MAIL_NEW,
			0, 0, NULL, },
	{ GNOME_APP_UI_ITEM, N_("Reply"), N_("Reply to the sender of the selected message(s)"), 
			folder_reply_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_MAIL_RPL,
			0, 0, NULL, },
	{ GNOME_APP_UI_ITEM, N_("Forward"), N_("Forward the selected message(s)"), 
			folder_forward_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_MAIL_FWD,
			0, 0, NULL, },
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("Print"), N_("Print the selected message(s)"), 
			folder_print_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_PRINT,
			0, 0, NULL, },
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("Delete"), N_("Mark the selected message(s) for deletion"), 
			folder_delete_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_TRASH,
			0, 0, NULL, },
	GNOMEUIINFO_END,
};

GnomeUIInfo folder_toolbar_postponed[] =
{
	{ GNOME_APP_UI_ITEM, N_("Refresh"), N_("Rebuild the folder's message list"), 
			folder_refresh_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_REFRESH,
			0, 0, NULL, },
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("Compose"), N_("Compose a new message"), 
			folder_compose_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_MAIL_NEW,
			0, 0, NULL, },
	{ GNOME_APP_UI_ITEM, N_("Edit"), N_("Modify the selected message(s)"), 
			folder_edit_cb, NULL, NULL,
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_BOOK_OPEN,
			0, 0, NULL, },
	{ GNOME_APP_UI_ITEM, N_("Delete"), N_("Mark the selected message(s) for deletion"), 
			folder_delete_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_TRASH,
			0, 0, NULL, },
	GNOMEUIINFO_END,
};

GnomeUIInfo folder_toolbar_outgoing[] =
{
	{ GNOME_APP_UI_ITEM, N_("Refresh"), N_("Rebuild the folder's message list"), 
			folder_refresh_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_REFRESH,
			0, 0, NULL, },
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("Read"), N_("Read the selected message(s)"), 
			folder_read_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_BOOK_OPEN,
			0, 0, NULL, },
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("Edit"), N_("Modify the selected message(s)"), 
			folder_edit_cb, NULL, NULL,
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_BOOK_OPEN,
			0, 0, NULL, },
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("Send"), N_("Send the selected message(s)"), 
			folder_send_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_MAIL_SND,
			0, 0, NULL, },
	{ GNOME_APP_UI_ITEM, N_("Send now"), N_("Send the selected message(s)"), 
			folder_send_now_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_MAIL_SND,
			0, 0, NULL, },
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("Print"), N_("Print the selected message(s)"), 
			folder_print_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_PRINT,
			0, 0, NULL, },
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("Delete"), N_("Mark the selected message(s) for deletion"), 
			folder_delete_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_TRASH,
			0, 0, NULL, },
	GNOMEUIINFO_END,
};

GnomeUIInfo folder_toolbar_sent[] =
{
	{ GNOME_APP_UI_ITEM, N_("Refresh"), N_("Rebuild the folder's message list"), 
			folder_refresh_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_REFRESH,
			0, 0, NULL, },
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("Read"), N_("Read the selected message(s)"), 
			folder_read_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_BOOK_OPEN,
			0, 0, NULL, },
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("Resend"), N_("Resend the selected message(s)"), 
			folder_send_again_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_MAIL_SND,
			0, 0, NULL, },
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("Print"), N_("Print the selected message(s)"), 
			folder_print_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_PRINT,
			0, 0, NULL, },
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("Delete"), N_("Mark the selected message(s) for deletion"), 
			folder_delete_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_TRASH,
			0, 0, NULL, },
	GNOMEUIINFO_END,
};

/* Message window toolbars.
 */
GnomeUIInfo mailmsg_toolbar[] =
{
	{ GNOME_APP_UI_ITEM, N_("Prev"), N_("Go to the message before this one"), 
			mailmsg_prev_msg_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_BACK,
			0, 0, NULL, },
	{ GNOME_APP_UI_ITEM, N_("Next"), N_("Got to the message after this one"), 
			mailmsg_next_msg_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_FORWARD,
			0, 0, NULL, },
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("Compose"), N_("Compose a new message"), 
			mailmsg_compose_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_MAIL_NEW,
			0, 0, NULL, },
	{ GNOME_APP_UI_ITEM, N_("Reply"), N_("Reply to the sender of this message"), 
			mailmsg_reply_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_MAIL_RPL,
			0, 0, NULL, },
	{ GNOME_APP_UI_ITEM, N_("Forward"), N_("Forward this message"), 
			mailmsg_forward_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_MAIL_FWD,
			0, 0, NULL, },
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("Print"), N_("Print this message"), 
			mailmsg_print_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_PRINT,
			0, 0, NULL, },
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("Delete"), N_("Mark this message for deletion"), 
			mailmsg_delete_cb, NULL, NULL, 
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_TRASH,
			0, 0, NULL, },
	GNOMEUIINFO_END,
};

/* Compose window toolbars.
 */
GnomeUIInfo compose_toolbar[] =
{
	{ GNOME_APP_UI_ITEM, N_("Send"), N_("Send this message"), 
			compose_send_cb, NULL, NULL,
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_MAIL_SND,
			0, 0, NULL, },
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("Insert"), N_("Insert a file"), 
			compose_insert_file_cb, NULL, NULL,
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_ADD,
			0, 0, NULL, },
	{ GNOME_APP_UI_ITEM, N_("Save"), N_("Save the text to a file"), 
			compose_save_cb, NULL, NULL,
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_SAVE,
			0, 0, NULL, },
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("Spell"), N_("Check spelling for this message"), 
			compose_spellcheck_cb, NULL, NULL,
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_SPELLCHECK,
			0, 0, NULL, },
	GNOMEUIINFO_SEPARATOR,
	{ GNOME_APP_UI_ITEM, N_("Cut"), N_("Cut the selected block"), 
			compose_cut_cb, NULL, NULL,
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_CUT,
			0, 0, NULL, },
	{ GNOME_APP_UI_ITEM, N_("Copy"), N_("Copy the selected block"), 
			compose_copy_cb, NULL, NULL,
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_COPY,
			0, 0, NULL, },
	{ GNOME_APP_UI_ITEM, N_("Paste"), N_("Paste the clipboard"), 
			compose_paste_cb, NULL, NULL,
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_PASTE,
			0, 0, NULL, },
	{ GNOME_APP_UI_ITEM, N_("Erase"), N_("Erase the selected block"), 
			compose_erase_cb, NULL, NULL,
			GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_PIXMAP_REMOVE,
			0, 0, NULL, },
	GNOMEUIINFO_END,
};

