/*
 * Eucalyptus
 * by Paul A. Schifferer
 *
 * Module: msg_print.c
 *         Support functions for message printing
 *
 * Copyright  1997-9 Isengard Developments
 * All rights reserved.
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "eucalyptus.h"

#if 0
struct PrintOptions *GetPrintOptions(struct MailMsg *msg)
{
     struct PrintOptions *popts = NULL;
     struct Window *window;
     Object *winobj = NULL;
     struct Gadget *layout, *device, *devices, *printtext, *printatts, *printraw, *printheaders, *listbrowser;
     struct List *devicelist, *headerslist, attachments;
     struct Node *node;

     if(!msg)
          return(NULL);

     NewList(&attachments);

     if(popts = AllocVec(sizeof(struct PrintOptions), MEMF_CLEAR))
     {
          NewList(&popts->WhichAtts);
          popts->Text = TRUE;
          strncpy(popts->Device, "PRT:", sizeof(popts->Device) - 1);

          if(!(devicelist = ChooserLabels("PRT:", "PAR:", "SER:", "AUX:", NULL)))
               goto out;

          if(!(headerslist = ChooserLabels(LocaleString(ETXT_PRINTOPTS_HEADER_NONE),
                                           LocaleString(ETXT_PRINTOPTS_HEADER_BRIEF),
                                           LocaleString(ETXT_PRINTOPTS_HEADER_ALL),
                                           NULL)))
               goto out;

          if(!GetMsgParts(msg))
          {
               struct MsgPart *mp;
               LONG i;

               for(mp = (struct MsgPart *)msg->Parts.lh_Head, i = 0;
                   mp->Node.ln_Succ;
                   mp = (struct MsgPart *)mp->Node.ln_Succ, i++)
               {
                    struct Node *node;

                    if(!i)
                         continue;

                    if(node = AllocListBrowserNode(1,
                              LBNA_Column,        0,
                                   LBNCA_CopyText,          TRUE,
                                   LBNCA_Text,              mp->Name,
                              LBNA_UserData,      i,
                              TAG_END))
                    {
                         AddTail(&attachments, node);
                    }
               }
          }

          if(winobj = NewObject(WINDOW_GetClass(), NULL,
                    WINDOW_Position,         WPOS_CENTERSCREEN,
                    WA_Width,                300,

                    WA_CloseGadget,          TRUE,
                    WA_DragBar,              TRUE,
                    WA_DepthGadget,          TRUE,
                    WA_SizeGadget,           TRUE,
                    WA_SizeBBottom,          TRUE,
                    WA_AutoAdjust,           TRUE,
                    WA_Activate,             TRUE,
                    WINDOW_BackFillName,     sprefs->Backfill,

                    WA_Title,                LocaleString(ETXT_TITLE_PRINTMSG),
                    WA_ScreenTitle,          eucsctitle,
                    WA_PubScreen,            euc.Screen,

                    WINDOW_Layout,      layout = VLayoutObject,
                         LAYOUT_DeferLayout,      TRUE,
                         LAYOUT_SpaceOuter,       TRUE,
                         StartVGroup,
                              LAYOUT_SpaceInner,  FALSE,
                              StartMember,   ButtonObject,
                                   GA_Text,                 msg->Index.From,
                                   BUTTON_Justification,    BCJ_LEFT,
                                   BUTTON_BevelStyle,       BVS_NONE,
                                   BUTTON_SoftStyle,        FSF_BOLD,
                                   BUTTON_Transparent,      TRUE,
                                   GA_ReadOnly,             TRUE,
                              EndMember,
                              MemberLabel(LocaleString(ETXT_GAD_PRINTOPTS_FROM)),
                              StartMember,   ButtonObject,
                                   GA_Text,                 msg->Index.Subject,
                                   BUTTON_Justification,    BCJ_LEFT,
                                   BUTTON_BevelStyle,       BVS_NONE,
                                   BUTTON_SoftStyle,        FSF_BOLD,
                                   BUTTON_Transparent,      TRUE,
                                   GA_ReadOnly,             TRUE,
                              EndMember,
                              MemberLabel(LocaleString(ETXT_GAD_PRINTOPTS_SUBJECT)),
                              StartMember,   ButtonObject,
                                   GA_Text,                 msg->Index.DateStr,
                                   BUTTON_Justification,    BCJ_LEFT,
                                   BUTTON_BevelStyle,       BVS_NONE,
                                   BUTTON_SoftStyle,        FSF_BOLD,
                                   BUTTON_Transparent,      TRUE,
                                   GA_ReadOnly,             TRUE,
                              EndMember,
                              MemberLabel(LocaleString(ETXT_GAD_PRINTOPTS_DATE)),
                         EndMember,
                         CHILD_WeightedHeight,    0,
                         StartHGroup,
                              StartImage,    BevelObject,
                                   BEVEL_Style,        BVS_SBAR_VERT,
                              EndImage,
                         EndGroup,
                         CHILD_WeightedHeight,    0,
                         StartHGroup,
                              LAYOUT_SpaceInner,       FALSE,
                              StartMember,   device = StringObject,
                                   STRINGA_TextVal,         popts->Device,
                                   STRINGA_MaxChars,        sizeof(popts->Device) - 1,
                                   GA_ID,                   GAD_PRINTOPTS_DEVICE,
                                   GA_RelVerify,            TRUE,
                              EndMember,
                              MemberLabel(LocaleString(ETXT_GAD_PRINTOPTS_DEVICE)),
                              StartMember,   devices = DropDownObject,
                                   CHOOSER_Labels,          devicelist,
                                   CHOOSER_AutoFit,         TRUE,
                                   CHOOSER_Title,           "",
                                   GA_Width,                20,
                                   GA_ID,                   GAD_PRINTOPTS_DEVICES,
                                   GA_RelVerify,            TRUE,
                              EndMember,
                         EndGroup,
                         CHILD_WeightedHeight,    0,
                         StartHGroup,
                              LAYOUT_VertAlignment,         LALIGN_TOP,
                              StartVGroup,
                                   StartMember,   printtext = CheckBoxObject,
                                        GA_Selected,        popts->Text,
                                        GA_Text,            LocaleString(ETXT_GAD_PRINTOPTS_TEXT),
                                        CHECKBOX_TextPlace, PLACETEXT_LEFT,
                                        GA_ID,              GAD_PRINTOPTS_TEXT,
                                        GA_RelVerify,       TRUE,
                                   EndMember,
                                   CHILD_WeightedHeight,    0,
                                   StartMember,   printatts = CheckBoxObject,
                                        GA_Selected,        popts->Attachments,
                                        GA_Text,            LocaleString(ETXT_GAD_PRINTOPTS_ATTACHMENTS),
                                        CHECKBOX_TextPlace, PLACETEXT_LEFT,
                                        GA_ID,              GAD_PRINTOPTS_ATTACHMENTS,
                                        GA_RelVerify,       TRUE,
                                        GA_Disabled,        popts->Raw ? TRUE : !(msg->Index.Flags & MIEF_ATTACHMENTS),
                                   EndMember,
                                   CHILD_WeightedHeight,    0,
                                   StartHGroup,
                                        StartImage,    BevelObject,
                                             BEVEL_Style,        BVS_SBAR_VERT,
                                        EndImage,
                                   EndGroup,
                                   CHILD_WeightedHeight,    0,
                                   StartMember,   printraw = CheckBoxObject,
                                        GA_Selected,        popts->Raw,
                                        GA_Text,            LocaleString(ETXT_GAD_PRINTOPTS_RAW),
                                        CHECKBOX_TextPlace, PLACETEXT_LEFT,
                                        GA_ID,              GAD_PRINTOPTS_RAW,
                                        GA_RelVerify,       TRUE,
                                   EndMember,
                                   CHILD_WeightedHeight,    0,
                                   StartHGroup,
                                        StartImage,    BevelObject,
                                             BEVEL_Style,        BVS_SBAR_VERT,
                                        EndImage,
                                   EndGroup,
                                   CHILD_WeightedHeight,    0,
                                   StartMember,   printheaders = PopUpObject,
                                        CHOOSER_Labels,     headerslist,
                                        CHOOSER_AutoFit,    TRUE,
                                        CHOOSER_Active,     popts->HeadersType,
                                        GA_ID,              GAD_PRINTOPTS_HEADERS,
                                        GA_RelVerify,       TRUE,
                                        GA_Disabled,        popts->Raw,
                                   EndMember,
                                   MemberLabel(LocaleString(ETXT_GAD_PRINTOPTS_HEADERS)),
                                   CHILD_WeightedHeight,    0,
                                   StartMember,   SpaceObject,
                                        SPACE_Transparent,       TRUE,
                                   EndMember,
                              EndGroup,
                              CHILD_WeightedWidth,          0,
                              StartMember,   listbrowser = ListBrowserObject,
                                   LISTBROWSER_Labels,           &attachments,
                                   LISTBROWSER_AutoFit,          TRUE,
                                   LISTBROWSER_ShowSelected,     TRUE,
                                   LISTBROWSER_MultiSelect,      TRUE,
                                   GA_ID,                        GAD_PRINTOPTS_LISTBROWSER,
                                   GA_RelVerify,                 TRUE,
                                   GA_Disabled,                  popts->Raw ? TRUE : ((msg->Index.Flags & MIEF_ATTACHMENTS) ? !popts->Attachments : TRUE),
                              EndMember,
                         EndGroup,
                         StartHGroup,
                              StartImage,    BevelObject,
                                   BEVEL_Style,        BVS_SBAR_VERT,
                              EndImage,
                         EndGroup,
                         CHILD_WeightedHeight,    0,
                         StartHGroup,
                              StartMember,   SpaceObject,
                                   SPACE_Transparent,       TRUE,
                              EndMember,
                              StartMember,   ButtonObject,
                                   GA_Text,            LocaleString(ETXT_BUTTON_PRINT),
                                   GA_ID,              GAD_USE,
                                   GA_RelVerify,       TRUE,
                              EndMember,
                              StartMember,   SpaceObject,
                                   SPACE_Transparent,       TRUE,
                              EndMember,
                         EndGroup,
                         CHILD_WeightedHeight,    0,
                    End,
                    TAG_END))
          {
               if(window = CA_OpenWindow(winobj))
               {
                    BOOL done = FALSE;

                    while(!done)
                    {
                         LONG signals;

                         signals = Wait((1L << window->UserPort->mp_SigBit) |
                                        SIG_KILL);

                         if(signals & SIG_KILL)
                         {
                              FreePrintOptions(popts);
                              popts = NULL;
                              done = TRUE;
                              Signal(FindTask(NULL), SIG_KILL);
                              break;
                         }

                         if(signals & (1L << window->UserPort->mp_SigBit))
                         {
                              LONG result;
                              WORD code = 0;

                              while(WMHI_LASTMSG != (result = CA_HandleInput(winobj, code)))
                              {
                                   switch(result & WMHI_CLASSMASK)
                                   {
                                        case WMHI_CLOSEWINDOW:
                                             FreePrintOptions(popts);
                                             popts = NULL;
                                             done = TRUE;
                                             break;
                                        case WMHI_GADGETUP:
                                             switch(result & WMHI_GADGETMASK)
                                             {
                                                  struct Node *node;
                                                  LONG val;
                                                  STRPTR text;

                                                  case GAD_PRINTOPTS_DEVICE:
                                                       GetAttr(STRINGA_TextVal, device, (ULONG *)&text);
                                                       if(text)
                                                            strncpy(popts->Device, text, sizeof(popts->Device) - 1);
                                                       break;
                                                  case GAD_PRINTOPTS_DEVICES:
                                                       GetAttr(CHOOSER_Active, devices, (ULONG *)&val);
                                                       if(node = GetListNum(devicelist, val))
                                                       {
                                                            GetChooserNodeAttrs(node,
                                                                      CNA_Text,      &text,
                                                                      TAG_END);
                                                            if(text)
                                                            {
                                                                 strncpy(popts->Device, text, sizeof(popts->Device) - 1);
                                                                 if(SetGadgetAttrs(device, window, NULL,
                                                                           STRINGA_TextVal,         popts->Device,
                                                                           TAG_END))
                                                                      RefreshGList(device, window, NULL, 1);
                                                            }
                                                       }
                                                       break;
                                                  case GAD_PRINTOPTS_LISTBROWSER:
                                                       break;
                                                  case GAD_PRINTOPTS_TEXT:
                                                       GetAttr(GA_Selected, printtext, (ULONG *)&val);
                                                       popts->Text = (BOOL)val;
                                                       break;
                                                  case GAD_PRINTOPTS_ATTACHMENTS:
                                                       GetAttr(GA_Selected, printatts, (ULONG *)&val);
                                                       popts->Attachments = (BOOL)val;
                                                       if(SetGadgetAttrs(listbrowser, window, NULL,
                                                                 GA_Disabled,        popts->Raw ? TRUE : ((msg->Index.Flags & MIEF_ATTACHMENTS) ? !popts->Attachments : TRUE),
                                                                 TAG_END))
                                                            RefreshGList(listbrowser, window, NULL, 1);
                                                       break;
                                                  case GAD_PRINTOPTS_RAW:
                                                       GetAttr(GA_Selected, printraw, (ULONG *)&val);
                                                       popts->Raw = (BOOL)val;
                                                       if(SetGadgetAttrs(printtext, window, NULL,
                                                                 GA_Disabled,        popts->Raw,
                                                                 TAG_END))
                                                            RefreshGList(printtext, window, NULL, 1);
                                                       if(SetGadgetAttrs(printatts, window, NULL,
                                                                 GA_Disabled,        popts->Raw ? TRUE : !(msg->Index.Flags & MIEF_ATTACHMENTS),
                                                                 TAG_END))
                                                            RefreshGList(printatts, window, NULL, 1);
                                                       if(SetGadgetAttrs(printheaders, window, NULL,
                                                                 GA_Disabled,        popts->Raw,
                                                                 TAG_END))
                                                            RefreshGList(printheaders, window, NULL, 1);
                                                       if(SetGadgetAttrs(listbrowser, window, NULL,
                                                                 GA_Disabled,        popts->Raw ? TRUE : ((msg->Index.Flags & MIEF_ATTACHMENTS) ? !popts->Attachments : TRUE),
                                                                 TAG_END))
                                                            RefreshGList(listbrowser, window, NULL, 1);
                                                       break;
                                                  case GAD_PRINTOPTS_HEADERS:
                                                       GetAttr(CHOOSER_Active, printheaders, (ULONG *)&val);
                                                       popts->HeadersType = (UBYTE)val;
                                                       break;
                                                  case GAD_USE:
                                                       GetAttr(STRINGA_TextVal, device, (ULONG *)&text);
                                                       if(text)
                                                            strncpy(popts->Device, text, sizeof(popts->Device) - 1);
                                                       while(node = RemHead(&attachments))
                                                       {
                                                            GetListBrowserNodeAttrs(node,
                                                                      LBNA_Selected,      &val,
                                                                      TAG_END);
                                                            if(val)
                                                            {
                                                                 AddTail(&popts->WhichAtts, node);
                                                            }
                                                            else
                                                                 FreeListBrowserNode(node);
                                                       }
                                                       done = TRUE;
                                                       break;
                                             }
                                             break;
                                   }
                              }
                         }
                    }
               }
               else
               {
                    FreePrintOptions(popts);
                    popts = NULL;
               }

               DisposeObject(winobj);
          }
          else
          {
               FreePrintOptions(popts);
               popts = NULL;
          }
     }

     out:
     if(devicelist)
          FreeChooserLabels(devicelist);
     if(headerslist)
          FreeChooserLabels(headerslist);

     while(node = RemHead(&attachments))
          FreeListBrowserNode(node);

     return(popts);
}

void FreePrintOptions(struct PrintOptions *popts)
{
     struct Node *node;

     if(!popts)
          return;

     while(node = RemHead(&popts->WhichAtts))
     {
          FreeListBrowserNode(node);
     }

     FreeVec(popts);
}

#endif
