#ifndef PATH_H
#define PATH_H

/*
 * path.h
 * by Paul A. Schifferer
 *
 * Function prototypes for path.c
 *
 * Copyright 1997-9 Isengard Developments
 * All rights reserved.
 */

glong path_add_part(gchar *, const gchar *, gint);
gchar **path_parse(const gchar *);
void path_free_items(gchar **);
gchar *path_file_part(gchar *);
gchar *path_dir_part(const gchar *);
gchar *path_build(const gchar *, ...);
gchar *path_prune_part(const gchar *);
gboolean path_create_directory(const gchar *);
gboolean path_is_file(const gchar *);
gboolean path_is_dir(const gchar *);
struct stat *path_stat(const gchar *);
gchar *path_metadata(const gchar *);

#endif /* PATH_H */
