/*
 * Eucalyptus
 * by Paul A. Schifferer
 *
 * Module: session.c
 *         GNOME session management functions
 *
 * Copyright (c) 1997-9 Isengard Developments
 * All rights reserved.
 */

#include "eucalyptus.h"

#ifdef USE_SESSIONMGMT

static void session_die(gpointer client_data)
{
	gtk_main_quit();
}

static int save_state(GnomeClient 		*client, 
				  gint			 phase,
				  GnomeRestartStyle	 save_style,
				  gint			 shutdown,
				  GnomeInteractStyle interact_style,
				  gint			 fast,
				  gpointer		 client_data)
{
	char *prefix = gnome_client_get_config_prefix(client);
	char *argv[] = { "rm", "-r", NULL, };
	
#if 0
	gnome_config_push_prefix(prefix);
	
	...
	
	gnome_config_pop_prefix();
	gnome_config_sync();
#endif	

	argv[2] = gnome_config_get_real_path(prefix);
	gnome_client_set_discard_command(client, 3, argv);
	
	argv[0] = (gchar *)client_data;
	gnome_client_set_clone_command(client, 1, argv);
	gnome_client_set_restart_command(client, 1, argv);
	
	return TRUE;
}

gboolean session_start_client(void)
{
	GnomeClient *client;
	gboolean success = FALSE;

	if(client = euc.GnomeClient = gnome_master_client())
	{
		gtk_signal_connect(GTK_OBJECT(client), "save_yourself", GTK_SIGNAL_FUNC(save_state), NULL);
		gtk_signal_connect(GTK_OBJECT(client), "die", GTK_SIGNAL_FUNC(session_die), NULL);
		
		if(GNOME_CLIENT_CONNECTED(client))
		{
			gnome_config_push_prefix(gnome_client_get_config_prefix(client));
			
			// some_value = gnome_config_get_int("Section/Key=0");
			
			gnome_config_pop_prefix();

			success = TRUE;
		}
	}

	return success;
}

#endif