/*
 * Eucalyptus
 * by Paul A. Schifferer
 *
 * Module: smtp.c
 *   	 SMTP client function server
 *
 * Copyright  1997-9 Isengard Developments
 * All rights reserved.
 */

#include <sys/types.h>
#include <sys/socket.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <netinet/in.h>
#include <netdb.h>
#include <gtk/gtk.h>

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "eucalyptus.h"

struct SMTPControl smtp_control;

void smtp_close_server(void)
{
	if(smtp_control.Sock >= 0)
	{
		send(smtp_control.Sock, "QUIT\r\n", 6, 0);
		shutdown(smtp_control.Sock, 2);
	}
	
	smtp_control.Sock = -1;
	smtp_control.Connected = FALSE;
}

glong smtp_send(glong sock, gchar *out_buf, gchar *in_buf, glong in_len)
{
	glong error = 0;

	if(-1 != send(sock, out_buf, strlen(out_buf), 0))
	{
		if(recv(sock, in_buf, in_len - 1, 0) > 0)
		{
			gchar *c;

			error = atol(in_buf);
			if(c = strchr(in_buf, ' '))
				strcpy(in_buf, c + 1);
		}
		else
			error = -1;
	}
	else
		error = -1;

	return(error);
}


