#ifndef EUCALYPTUS_STRUCTS_H
#define EUCALYPTUS_STRUCTS_H

/*
 * Eucalyptus
 * by Paul A. Schifferer
 *
 * Header: structs.h
 *
 * Copyright  1997-9 Isengard Developments
 * All rights reserved.
 */

#include <gtk/gtk.h>
#include <glib.h>

#include "list.h"

/* File requesters.
 */
struct _FileReq
{
	glong type;
	GtkWidget *requester;
};

enum
{
	FILEREQ_COMPOSE_FORM,
	FILEREQ_COMPOSE_ADDRBOOK,
	FILEREQ_COMPOSE_INSERT_FILE,
	FILEREQ_COMPOSE_INSERT_FORM,
	FILEREQ_COMPOSE_INSERT_UUENCODE,
	FILEREQ_COMPOSE_INSERT_BRACKET,
	FILEREQ_COMPOSE_INSERT_INDENTED
};

/* Settings type structures.
 */
struct _Viewer
{
	glong					 Row;
     gchar                          Type[101],
                                    Action[FILENAME_MAX],
                                    Preprocess[FILENAME_MAX];
	gboolean					 Disabled;
};

struct _Filter
{
     glong                          Priority,
                                    Type,
							 Row;
     gchar                          Tag[101],
                                    Pattern[201],
                                    Action[FILENAME_MAX],
							 PriText[5];
     gboolean                       Disabled,
                                    Last;
};

// FilterNode Types
#define FNT_MOVE              (0)
#define FNT_COPY              (1)
#define FNT_FORWARD           (2)
#define FNT_REPLY             (3)
#define FNT_DELETE            (4)
#define FNT_EXECUTE           (5)

struct ContentType
{
	gchar 			*Name;
	glong			 Value;
};

struct ContentNode
{
	gchar			cn_FullName[101],
					cn_Type[101],
					cn_SubType[101];
     glong               cn_Value;
};

struct FlagNode
{
     gint                New,
                         Unread,
                         Replied,
                         Forwarded,
                         Bounced,
                         Deleted,
                         DontDelete,
                         Notify;
};

// FlagNode states
#define FNSF_IGNORE      (0)
#define FNSF_SET         (1)
#define FNSF_CLEAR       (2)

struct _Macro
{
     gint                      Position;
     gchar                    *Name, // [31],
                              *Path; // [331];
};

struct PrintOptions
{
     struct List	           WhichAtts;
     gboolean                  Text,
                               Attachments,
                               Raw;
     gchar                    *Device; // [51],
     gchar                     HeadersType;
};

// HeadersTypes
#define POHT_NONE             (0)
#define POHT_BRIEF            (1)
#define POHT_ALL              (2)

#if 0
struct User
{
	gchar			*Name,
					*Username,
					*Directory;
};
#endif

#include "list.h"
#include "emsgs.h"

#endif /* EUCALYPTUS_STRUCTS_H */
