/*
 * Eucalyptus
 * by Paul A. Schifferer
 *
 * Module: users.c
 *   	 Multi-user functions
 *
 * Copyright  1997-9 Isengard Developments
 * All rights reserved.
 */

#include <stdio.h>
#include <string.h>

#include "eucalyptus.h"
#include "md5.h"

void user_get_info(void)
{
	gchar domainname[256], *text, *dir;
	
	/* Real name.
	 */
	strncpy(uprefs.RealName, g_get_real_name(), sizeof(uprefs.RealName) - 1);

	/* Email address.
	 */
	getdomainname((char *)domainname, sizeof(domainname) - 1);
	if(!*domainname)
		gethostname((char *)domainname, sizeof(domainname) - 1);
	text = g_strdup_printf("%s@%s", g_get_user_name(), domainname);
	strncpy(uprefs.Address, text, sizeof(uprefs.Address) - 1);
	g_free(text);

	/* Directories and files.
	 */
	dir = g_get_home_dir();

	text = path_build(dir, ".signature", NULL);
	strncpy(uprefs.Signature, text, sizeof(uprefs.Signature) - 1);
	g_free(text);

	text = path_build(dir, ".taglines", NULL);
	strncpy(uprefs.Taglines, text, sizeof(uprefs.Taglines) - 1);
	g_free(text);

	text = path_build(dir, ".addresses", NULL);
	strncpy(uprefs.AddressBook, text, sizeof(uprefs.AddressBook) - 1);
	g_free(text);

	text = path_build(dir, "Mail", NULL);
	strncpy(uprefs.MailDir, text, sizeof(uprefs.MailDir) - 1);
	g_free(text);

	text = path_build(dir, ".mailcap", NULL);
	strncpy(uprefs.Mailcap, text, sizeof(uprefs.Mailcap) - 1);
	g_free(text);

	text = path_build(dir, ".filters", NULL);
	strncpy(uprefs.Filters, text, sizeof(uprefs.Filters) - 1);
	g_free(text);

}

