/*
 * Eucalyptus
 * by Paul A. Schifferer
 *
 * Module: uudecode.c
 *         UUdecoding routines
 *
 * Copyright  1997-9 Isengard Developments
 * All rights reserved.
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>

#include "eucalyptus.h"

gboolean mailmsg_uudecode(MailMsg *msg)
{
     FILE *fp;
     gchar buf[1024], uufile[51], *savepath = NULL, *fname, *dir;
     gboolean success = TRUE;

     if(!msg)
          return FALSE;
          
     fname = mailmsg_get_full_path(msg);

     if(fp = fopen(fname, "r"))
     {
          gchar *c;
          
          savepath = g_strdup(g_get_home_dir());

          while(fgets(buf, sizeof(buf) - 1, fp))
          {
               if(!strncasecmp(buf, "begin ", 6))
               {
                    memset(uufile, 0, sizeof(uufile));

                    if(isdigit(buf[6]) &&
                       isdigit(buf[7]) &&
                       isdigit(buf[8]) &&
                       (buf[9] == ' '))
                    {
                    	GtkWidget *getfile;

                         if(c = strchr(buf + 6, ' '))
                              strncpy(uufile, strip_leading_blanks(c + 1), sizeof(uufile) - 1);
                         if(c = strchr(uufile, '\r'))
                              *c = '\0';
                         if(c = strchr(uufile, '\n'))
                              *c = '\0';

#if 0
                         if(getfile = NewObject(GETFILE_GetClass(), NULL,
                                   GETFILE_Drawer,     savepath,
                                   GETFILE_File,       uufile,
                                   GETFILE_DoSaveMode, TRUE,
                                   TAG_END))
                         {
                              if(CA_RequestFile(getfile, msg->Window))
                              {
                                   STRPTR outfile;

                                   GetAttr(GETFILE_Drawer, getfile, (ULONG *)&outfile);
                                   if(outfile)
                                        strncpy(savepath, outfile, sizeof(savepath) - 1);

                                   GetAttr(GETFILE_FullFile, getfile, (ULONG *)&outfile);
                                   if(outfile)
                                   {
                                        struct AsyncFile *out_fp;

                                        if(out_fp = OpenAsync(outfile, MODE_WRITE, ASYNCIO_BUF, SysBase, DOSBase))
                                        {
                                             while(FGetsAsync(fp, buf, WORKLEN - 1))
                                             {
                                                  glong n;
                                                  gchar *p;

                                                  n = DEC(buf[0]);
                                                  if (n <= 0)
                                                       break;

                                                  p = &buf[1];
                                                  while (n > 0)
                                                  {
//                                                          int c;

                                                       if (n >= 1)
                                                            WriteCharAsync(out_fp, (DEC((*p == '`') ? ' ' : *p) << 2) | (DEC((p[1] == '`') ? ' ' : p[1]) >> 4));
                                                       if (n >= 2)
                                                            WriteCharAsync(out_fp, (DEC((p[1] == '`') ? ' ' : p[1]) << 4) | (DEC((p[2] == '`') ? ' ' : p[2]) >> 2));
                                                       if (n >= 3)
                                                            WriteCharAsync(out_fp, (DEC((p[2] == '`') ? ' ' : p[2]) << 6) | (DEC((p[3] == '`') ? ' ' : p[3])));

                                                       p += 4;
                                                       n -= 3;
                                                  }
                                             }

                                             CloseAsync(out_fp);
                                        }
                                   }
                              }

                              DisposeObject(getfile);
                         }
#endif
                    }
               }
          }

          fclose(fp);
     }
     else
     	success = FALSE;
     
     g_free(savepath);
     g_free(fname);

     return success;
}

